/*
Ŀ
 VPAGE.C                                      
 Copyright (C)1994,1996 Ivan Ristic           

*/


#include <malloc.h>
#include <dos.h>

int *getcr3();
int  getcr0();

#define _CR0 getcr0()
#define _CR3 getcr3()

void   new14(void);
extern int  *pagedir;
extern int   vbase;
extern void _FatalError(char *m);

char *pagemem;
int   pagenumber;

void *DosMalloc (int size)
/************************/
{
    union REGS r;

    // DPMI call to allocate DOS memory (below 640k)

    r.x.eax=0x0100;
    r.x.ebx=(size+15)>>4;
    int386(0x31, &r, &r);

    if (r.x.cflag) return (NULL);
    return (void *) ((r.x.eax & 0xFFFF) << 4);
}

int StartVideoPaging(void)
/************************/
{
    int *r;
    int  i,b;
    char *p;

    // is PG bit set?

    if (!(_CR0 & 0x80000000)) {
        _FatalError("PG bit is not set.");
        return(-1);
    }


    // searching for an empty slot

    r=_CR3;
    pagenumber=0;
    while(*r++!=0) pagenumber++;

    pagemem=DosMalloc(8200);
    if (pagemem==NULL) {
        _FatalError("Could not allocate memory for video paging.");
        return(-1);
    }


    p=(char *)pagemem;
    while( (int)p & 0xFFF) p++;

    pagedir=(int *)p;


    r=pagedir;
    for(b=0;b<16;b++) *r++=((0xa0+b)<<12)+1;      // 16 pages are in mem.

    for(i=0;i<31;i++)
        for(b=0;b<16;b++) *r++=(0xa0+b)<<12;      // 496 not

    vbase=pagenumber<<22;


    // install PAGE FAULT handler

    if (Set14Handler()) {
        free(pagemem);
        _FatalError("PF handler could not be installed.");
        return(-1);
    }


    // now, we'll put our secundary page to list

    r=_CR3;

    *(r+pagenumber)=((int)pagedir&0xFFFFF000)+1;

    // _CR3 look like this
    //
    // mov eax,cr3
    // mov cr3,eax
    //
    // we need this call to reset internal cache

    r=_CR3;

    return(0);
}

int Set14Handler(void)
/********************/
{
    union REGS r;

    r.x.eax=0x203;
    r.x.ebx=14;
    r.x.ecx=FP_SEG(new14);
    r.x.edx=FP_OFF(new14);
    int386(0x31,&r,&r);

    if (r.x.cflag&1) return(-1);
    else return(0);
}

void KillVideoPaging(void)
/************************/
{
    // you can remove the page now
    // (we do not have to deallocate DOS memory - the DOS4GW does
    // that for us

    *(_CR3+pagenumber)=0;
}
